function varargout = Rename_images(varargin)
% RENAME_IMAGES MATLAB code for Rename_images.fig
%      RENAME_IMAGES, by itself, creates a new RENAME_IMAGES or raises the existing
%      singleton*.
%
%      H = RENAME_IMAGES returns the handle to a new RENAME_IMAGES or the handle to
%      the existing singleton*.
%
%      RENAME_IMAGES('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RENAME_IMAGES.M with the given input arguments.
%
%      RENAME_IMAGES('Property','Value',...) creates a new RENAME_IMAGES or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Rename_images_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Rename_images_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Rename_images

% Last Modified by GUIDE v2.5 15-Aug-2012 09:04:19

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @Rename_images_OpeningFcn, ...
    'gui_OutputFcn',  @Rename_images_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Rename_images is made visible.
function Rename_images_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Rename_images (see VARARGIN)

% Choose default command line output for Rename_images
handles.output = hObject;

f_ext = {'CR2', 'NEF', 'DNG', 'TIFF'};
handles.file_extension = f_ext{1};
set(handles.popupmenu_fileExtension, 'String', f_ext);

set(handles.radiobutton_onefolder, 'Value', 0);
set(handles.radiobutton_separatefolders, 'Value', 1);
handles.separate_folders = 1;

handles.rename = 1;
set(handles.checkbox_rename, 'Value', 1);

set(handles.edit_rename, 'String', 'img');



set(handles.edit_startindex, 'String', '1');
handles.startindex = 1;



% Update handles structure
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = Rename_images_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function edit_visDir_Callback(hObject, eventdata, handles)
% hObject    handle to edit_visDir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_visDir as text
%        str2double(get(hObject,'String')) returns contents of edit_visDir as a double


% --- Executes during object creation, after setting all properties.
function edit_visDir_CreateFcn(hObject, eventdata, handles)
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_nirDir_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nirDir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nirDir as text
%        str2double(get(hObject,'String')) returns contents of edit_nirDir as a double


% --- Executes during object creation, after setting all properties.
function edit_nirDir_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_output_Callback(hObject, eventdata, handles)
% hObject    handle to edit_output (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_output as text
%        str2double(get(hObject,'String')) returns contents of edit_output as a double


% --- Executes during object creation, after setting all properties.
function edit_output_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_start.
function pushbutton_start_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_start (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.new_name = get(handles.edit_rename, 'String');
handles.pathname_vis = get(handles.edit_vis, 'String');
handles.pathname_nir = get(handles.edit_nir, 'String');

foo = dir([handles.pathname_vis '/*.' handles.file_extension]);
filenames_vis = {foo.name};
foo = dir([handles.pathname_nir '/*.' handles.file_extension]);
filenames_nir = {foo.name};

if(length(filenames_vis) ~= length(filenames_nir))
    error(['Not the same number of ' handles.file_extension ' files the the visible and nir folders!'])
end



num_images = size(filenames_vis, 2);
%num_length = ceil(log10(num_images));

if(handles.separate_folders == 1)
    %Create directories if they don't yet exist
    if(~exist([handles.pathname_output '/visible/'], 'dir'))
        disp('Directory does not exist. Creating it for you...');
        mkdir([handles.pathname_output '/visible/']);
    end
    
    if(~exist([handles.pathname_output '/nir/'], 'dir'))
        disp('Directory does not exist. Creating it for you...');
        mkdir([handles.pathname_output '/nir/']);
    end
    for i=1:num_images
        if(handles.rename == 1)
            num = sprintf('%0.3d', i+handles.startindex - 1);
            
            copyfile([handles.pathname_vis '/' filenames_vis{i}], [handles.pathname_output '/visible/' handles.new_name '_' num '.'  lower(handles.file_extension)]);
            copyfile([handles.pathname_nir '/' filenames_nir{i}], [handles.pathname_output '/nir/' handles.new_name '_' num '.' lower(handles.file_extension)]);
        else
            copyfile([handles.pathname_vis '/' filenames_vis{i}], [handles.pathname_output '/visible/' filenames_vis{i}]);
            copyfile([handles.pathname_nir '/' filenames_nir{i}], [handles.pathname_output '/nir/' filenames_vis{i}]);
        end
    end
else
    for i=1:num_images
        %Create directory if if it doesn't yet exist
        if(~exist(handles.pathname_output', 'dir'))
            disp('Directory does not exist. Creating it for you...');
            mkdir(handles.pathname_output');
        end
        if(handles.rename == 1)
            num = sprintf('%0.3d', i+handles.startindex - 1);
            
            copyfile([handles.pathname_vis '/' filenames_vis{i}], [handles.pathname_output '/' handles.new_name '_' num '_vis.'  lower(handles.file_extension)]);
            copyfile([handles.pathname_nir '/' filenames_nir{i}], [handles.pathname_output '/' handles.new_name '_' num '_nir.' lower(handles.file_extension)]);
        else
            error('This makes no sense.');
        end
    end
end


% --- Executes on button press in pushbutton_visible.
function pushbutton_visible_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_visible (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.pathname_vis = uigetdir('./');

set(handles.edit_vis, 'String', handles.pathname_vis);

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in pushbutton_nir.
function pushbutton_nir_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_nir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.pathname_nir = uigetdir('./');

set(handles.edit_nir, 'String', handles.pathname_nir);

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in pushbutton_output.
function pushbutton_output_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_output (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.pathname_output = uigetdir('./');

set(handles.edit_output, 'String', handles.pathname_output);

% Update handles structure
guidata(hObject, handles);


function edit_rename_Callback(hObject, eventdata, handles)
% hObject    handle to edit_rename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_rename as text
%        str2double(get(hObject,'String')) returns contents of edit_rename as a double


% --- Executes during object creation, after setting all properties.
function edit_rename_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_rename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox_rename.
function checkbox_rename_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_rename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_rename

handles.rename = get(hObject, 'Value');

if(handles.rename == 1)
    set(handles.edit_rename, 'Enable', 'on');
    set(handles.edit_startindex, 'Enable', 'on');
    set(handles.text18, 'Enable', 'on');
else
    set(handles.edit_rename, 'Enable', 'off');
    set(handles.edit_startindex, 'Enable', 'off');
    set(handles.text18, 'Enable', 'off');
end

% Update handles structure
guidata(hObject, handles);


function edit_vis_Callback(hObject, eventdata, handles)
% hObject    handle to edit_vis (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_vis as text
%        str2double(get(hObject,'String')) returns contents of edit_vis as a double




% --- Executes during object creation, after setting all properties.
function edit_vis_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_vis (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_nir_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nir as text
%        str2double(get(hObject,'String')) returns contents of edit_nir as a double


% --- Executes during object creation, after setting all properties.
function edit_nir_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_nir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_fileExtension.
function popupmenu_fileExtension_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_fileExtension (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_fileExtension contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_fileExtension
contents = cellstr(get(hObject,'String'));
handles.file_extension = contents{get(hObject,'Value')};

% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function popupmenu_fileExtension_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_fileExtension (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_startindex_Callback(hObject, eventdata, handles)
handles.startindex = str2num(get(hObject,'String'));

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_startindex_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_startindex (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in radiobutton_separatefolders.
function radiobutton_separatefolders_Callback(hObject, eventdata, handles)
set(handles.radiobutton_onefolder, 'Value', 0);
set(handles.radiobutton_separatefolders, 'Value', 1);
handles.separate_folders = 1;

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in radiobutton_onefolder.
function radiobutton_onefolder_Callback(hObject, eventdata, handles)
set(handles.radiobutton_onefolder, 'Value', 1);
set(handles.radiobutton_separatefolders, 'Value', 0);
handles.separate_folders = 0;

% Update handles structure
guidata(hObject, handles);
