function im_srgb = cRGB2sRGB(im, M_cRGB2XYZ)

%XYZ to sRGB conversion matrix
M_XYZ2sRGB = [3.2410 -1.5374 -0.4986;
             -0.9692 1.8760 0.0416;
              0.0556 -0.2040 1.0570];

% Determine XYZ white point value under illuminant E
E=whitepoint('d65');
E=diag(E);

% RGB_WB = (1 1 1) will be mapped to XYZ under specified illuminant value
M_XYZ2sRGB=M_XYZ2sRGB*E;

%Compute conversion matrix from cRGB to sRGB
M = M_XYZ2sRGB*M_cRGB2XYZ;

%Convert input image from cRGB to linear sRGB
[m,n,c] = size(im);
im = reshape(im,  m*n, c);
im = im';
im_srgb = M*im;
%Put output image to matrix form
im_srgb = reshape(im_srgb', m, n, c);