function premul = compute_premultipliers(handles)
%This function computes the premultipliers based on the quantum efficiency
%of the cameras.

premul = zeros(2, 4);
switch handles.input_type
    case 'vis'
        spectral_sensitivities = handles.cameras{handles.rowCam1, 4};
        spectrum = 1:38;
        quant_eff = [trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,2)), trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,3)), trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,4))];
        new_weights = quant_eff(2)./quant_eff;
        premul(1,:) = [new_weights(1) new_weights(2) new_weights(3) new_weights(2)];
        
    case 'nir'
        spectral_sensitivities = handles.cameras{handles.rowCam1, 4};
        spectrum = 38:54;
        quant_eff = [trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,2)), trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,3)), trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,4))];
        new_weights = quant_eff(2)./quant_eff;
        premul(1,:) = [new_weights(1) new_weights(2) new_weights(3) new_weights(2)];
    
    case 'visnir'
        spectral_sensitivities = handles.cameras{handles.rowCam1, 4};
        spectrum = 1:38;
        quant_eff = [trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,2)), trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,3)), trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,4))];
        new_weights = quant_eff(2)./quant_eff;
        premul(1,:) = [new_weights(1) new_weights(2) new_weights(3) new_weights(2)];
        
        spectral_sensitivities = handles.cameras{handles.rowCam1, 4};
        spectrum = 38:54;
        quant_eff = [trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,2)), trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,3)), trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,4))];
        new_weights = quant_eff(2)./quant_eff;
        premul(2,:) = [new_weights(1) new_weights(2) new_weights(3) new_weights(2)];
    
    case 'tworaw'
        spectral_sensitivities = handles.cameras{handles.rowCam1, 4};
        spectrum = 1:38;
        quant_eff = [trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,2)), trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,3)), trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,4))];
        new_weights = quant_eff(2)./quant_eff;
        premul(1,:) = [new_weights(1) new_weights(2) new_weights(3) new_weights(2)];
        
        spectral_sensitivities = handles.cameras{handles.rowCam2, 4};
        spectrum = 38:54;
        quant_eff = [trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,2)), trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,3)), trapz(spectral_sensitivities(spectrum,1), spectral_sensitivities(spectrum,4))];
        new_weights = quant_eff(2)./quant_eff;
        premul(2,:) = [new_weights(1) new_weights(2) new_weights(3) new_weights(2)];
end