function index_matrix = get_cfa_index(mat)
%mat: String (RGGB)

red_pos = strfind(mat, 'R');
green_pos = strfind(mat, 'G');
blue_pos = strfind(mat, 'B');
nir_pos = strfind(mat, 'N');

if(isempty(nir_pos))
    nir_pos = -20;
end

num_cols = sqrt(length(mat));

index_matrix = zeros(4,2);

%Always take the position of the first occurence of the color channel
index_matrix = [floor((red_pos(1)-1)/num_cols) + 1, mod(red_pos(1)-1, num_cols) + 1; floor((green_pos(1)-1)/num_cols) + 1, mod(green_pos(1)-1, num_cols) + 1; ...
    floor((blue_pos(1)-1)/num_cols) + 1, mod(blue_pos(1)-1, num_cols) + 1; floor((nir_pos(1)-1)/num_cols) + 1, mod(nir_pos(1)-1, num_cols) + 1];


if(length(red_pos) > 1)
    index_matrix(4,:) = [floor((red_pos(2)-1)/num_cols) + 1, mod(red_pos(2)-1, num_cols) + 1];
end
if(length(green_pos) > 1)
    index_matrix(4,:) = [floor((green_pos(2)-1)/num_cols) + 1, mod(green_pos(2)-1, num_cols) + 1];
end
if(length(blue_pos) > 1)
    index_matrix(4,:) = [floor((blue_pos(2)-1)/num_cols) + 1, mod(blue_pos(2)-1, num_cols) + 1];
end