// helpers.h

#pragma once

#include "Parameter.h"
#include "Matrix.h"
#include "Image.h"

void ExtractDAISY(CMatrixf &ip, CMatrixf &desc, const CImagef &im, const CParameter &Param);

void FindNN(CMatrixi &NN, CMatrixf &NNdist, const CMatrixf &desc1, const CMatrixf &desc2);
void RatioTest(CArrayi &matchID, const CMatrixf &NNdist, float outlierDist);

void RANSACSimilarity(CArrayi &inliersID, CMatrixf &S, const CMatrixf &u1, const CMatrixf &u2, const CArrayi &imSize1, const CArrayi &imSize2, const CParameter &Param);
int ConsistentH(const CMatrixf &u1h, const CMatrixf &u2h, const CMatrixf H, const CMatrixf Hinv, const CArrayi &imageSize1, const CArrayi &imageSize2, float epsilon, CArrayi &consistent, CMatrixf &dist, CMatrixf &u1ht, CMatrixf &u2ht);
CMatrixf Inverse3x3(const CMatrixf &A);
CMatrixf ComputeSimilarity(const CMatrixf &u0, const CMatrixf &u1);

void SolveLinearSystem(CMatrixf &x, const CMatrixf &A0, const CMatrixf &b0);
void SolveLeastSquares(CMatrixf &x, const CMatrixf &A, const CMatrixf &b);

void ComputeImageCoords(CImagef &imCoord, const CArrayi &imSize, const CMatrixf &S);
void SampleImageBilinear(CImagef &renderIm, CImagei &alphaIm, const CImagef &imCoord, const CImagef &image);
CArrayi FindLargestRect(const CImagei &alphaImage);
