// Matrixf.h

#pragma once

#include "Matrix.h"

void WritePPM(const CMatrixf& M, const char* filename);

void Hom(CMatrixf &M, const CMatrixf &M1);
CMatrixf Hom(const CMatrixf &M1);
void UnHom(CMatrixf &M, const CMatrixf &M1);
CMatrixf UnHom(const CMatrixf &M1);

void NormaliseHomInPlace(CMatrixf &M);

void NormaliseHom(CMatrixf &M, const CMatrixf &M1);
CMatrixf NormaliseHom(const CMatrixf &M1);
void NormaliseUnit(CMatrixf &M, const CMatrixf &M1);
CMatrixf NormaliseUnit(const CMatrixf &M1);
void NormaliseLine(CMatrixf &M, const CMatrixf &M1);
CMatrixf NormaliseLine(const CMatrixf &M1);

CMatrixf K(float f);
CMatrixf Rx(float theta);
CMatrixf Ry(float theta);
CMatrixf Rz(float theta);
CMatrixf VectorRotation(const CMatrixf &theta);
CMatrixf RotationVector(const CMatrixf &R);
CMatrixf CrossMatrix(const CMatrixf &thetaHat);
CMatrixf RotationBetweenVectors(const CMatrixf &u1, const CMatrixf &u2);

//CMatrixf SolveLinearSystem(CMatrixf &M, CMatrixf &v);

void ConvolveGaussian(CMatrixf &CM, const CMatrixf &M, float sigma);


