// Parameter.h

#pragma once

#include <string>
#include <vector>

using namespace std;

class CParameter
{
public:	
    CParameter() : m_allStr("all") { };
    ~CParameter() { };
    
    void ReadParamFile(const char *filename);
    void ReadCommandLine(int argc, char* argv[]);
    
    string Gets(const char* param) const;
    int    Geti(const char* param) const;
    float  Getf(const char* param) const;
    bool   Getb(const char* param) const;

    void Set(string param, string value); 
    void Set(const char* param, string value);
    void Set(const char* param, const char* s);
    void Set(const char* param, int i);
    void Set(const char* param, float f);
    void Set(const char* param, bool b);

    void Set(const CParameter &paramIn);
    void SetNamed(const CParameter &paramIn, string name);
    void SetNamedKeepPrefix(const CParameter &paramIn, string name);

    bool Exists(const char* param) const;

    void Clear(void);
    void Dump(void) const;

    vector<string> m_param;
    vector<string> m_value;
    
    const string m_allStr;
};

