// Useful.h

#pragma once

#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <sstream>

using namespace std;

template <class T> ostream& operator<<(ostream &os, const vector<T> &v);
template <class T> istream& operator>>(istream &is, vector<T> &v);
istream& operator>>(istream &is, vector<bool> &v);

template <class T> string NumToString(T num);
template <class T> string NumToStringWidth(T num, int width);
template <class T> string NumToStringPrecision(T num, int precision);

template <class T> T Sgn(T t);
template <class T> void Swap(T &t1, T &t2);

bool XOr(bool b1, bool b2);
void ClampAngle(float &theta); // clamp angle 0->2*pi
string ToLower(string str);
string GetFileExtension(string filename);
string GetFileBasename(string filename);

bool operator==(string s1, const char* s2);

namespace NUseful
{
    static bool          dumBool;
    static unsigned char dumUChar;
    static int           dumInt;
    static float         dumFloat;

    static bool tst;
}

// Implementation of template functions

template <class T>
T Sgn(T t)
{
    if (t < 0)
        return (T)(-1);
    else
        return (T)1;
}

template <class T> 
void Swap(T &t1, T &t2)
{
    T tmp;
    tmp = t1;
    t1 = t2;
    t2 = tmp;
}

template <class T>
string NumToString(T num)
{
    stringstream ss;
    ss << num;
    return ss.str();    
}

template <class T>
string NumToStringWidth(T num, int width)
{
    stringstream ss;
    ss << setfill('0') << setw(width) << num;
    return ss.str();
}

template <class T>
string NumToStringPrecision(T num, int precision)
{
    stringstream ss;
    ss << setprecision(precision) << num;
    return ss.str();
}

template <class T> ostream& operator<<(ostream &os, const vector<T> &v)
{
  int sz = (int)v.size();
  os << sz << endl;
  for (int i = 0; i < sz; i++)
    os << v[i] << " ";
  os << endl;
  return os;
}

template <class T> istream& operator>>(istream &is, vector<T> &v)
{
  int sz;
  is >> sz;
  v.resize(sz);
  for (int i = 0; i < sz; i++)
    is >> v[i]; 
  return is;
}
