function x = interp_bilinear(x, nir_info)

switch size(x, 3)
    case 1
        if(strcmp(nir_info, 'G'))
            fg = [0.0 0.25 0.0; 0.25 1.0 0.25; 0.0 0.25 0.0];
            x = imfilter(x, fg, 'conv');
        else
            frb = [0.25, 0.5, 0.25; 0.5, 1, 0.5; 0.25, 0.5, 0.25];
            x = imfilter(x, frb, 'conv');
        end
    case 3
        frb = [0.25, 0.5, 0.25; 0.5, 1, 0.5; 0.25, 0.5, 0.25];
        fg = [0.0 0.25 0.0; 0.25 1.0 0.25; 0.0 0.25 0.0];
        x(:,:,1) = imfilter(x(:,:,1), frb, 'conv');
        x(:,:,2) = imfilter(x(:,:,2), fg, 'conv');
        x(:,:,3) = imfilter(x(:,:,3), frb, 'conv');
        
    otherwise
        error('Wrong input type. Either use a color image (RGB) or a monochromatic image.')
end
