function out = local_tm(in, sigma, kappa)

%Create Gaussian filter approximation
f = gaussFilter(sigma);

x0 = zeros(size(in));
out = zeros(size(in));

for i=1:size(in, 3)
    %Compute low-pass image
    x0(:,:,i) = imfilter(in(:,:,i), f, 'symmetric', 'same', 'conv') + mean(mean(in(:,:,i)))*kappa;
    
    %Apply naka-rushton
    out(:,:,i) = (max(max(in(:,:,i))) + x0(:,:,i)).*in(:,:,i)./(in(:,:,i)+x0(:,:,i));
end